# -*- coding: utf-8 -*-
# Generated by Django 1.11.17 on 2021-09-22 19:20
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('customers', '0063_auto_20210922_1620'),
        ('providers', '0007_auto_20201202_0827'),
    ]
    sql = """
CREATE OR REPLACE VIEW public.providers_financialrecord AS 
 SELECT 'I'::text || providers_invoice.id::text AS record_id,
    providers_invoice.paid,
    providers_invoice.due_date AS ts,
    providers_invoice.total AS original_charge,
    NULL::integer AS original_credit,
    CASE
            WHEN providers_invoice.tasa IS NULL THEN providers_invoice.total
            WHEN providers_invoice.tasa IS NOT NULL THEN sum(providers_invoice.total*providers_invoice.tasa)
            ELSE NULL::integer
        END AS charge,
    NULL::integer AS credit,
    providers_invoice.currency_id,
    providers_invoice.tasa,
    ((providers_invoice.comment::text || ' (Folio: '::text) || providers_invoice.folio::text) || ')'::text AS comment,
    providers_invoice.provider_id
   FROM providers_invoice
    GROUP BY providers_invoice.id
UNION
 SELECT 'P'::text || providers_payment.id::text AS record_id,
    true AS paid,
    providers_payment.paid_on AS ts,
    NULL::integer AS original_charge,
    providers_payment.amount AS original_credit,
    NULL::integer AS charge,
    CASE
            WHEN providers_payment.tasa IS NULL THEN providers_payment.amount
            WHEN providers_payment.tasa IS NOT NULL THEN sum(providers_payment.amount*providers_payment.tasa)
            ELSE NULL::integer
        END AS credit,
    providers_payment.currency_id,
    providers_payment.tasa,
    providers_payment.comment,
    providers_payment.provider_id
   FROM providers_payment
    GROUP BY providers_payment.id
  ORDER BY 3 DESC
    """
    balance_sql = """
    CREATE OR REPLACE VIEW public.providers_balance AS 
    SELECT c.id,
    c.id AS provider_id,
    COALESCE(sum(fr.credit), 0::bigint) - COALESCE(sum(fr.charge), 0::bigint) AS balance
   FROM providers_provider c
     LEFT JOIN providers_financialrecord fr ON c.id = fr.provider_id
  GROUP BY c.id
    """
    operations = [
        migrations.RunSQL("DROP VIEW IF EXISTS providers_balance"),
        migrations.RunSQL("DROP VIEW IF EXISTS providers_financialrecord"),
        migrations.AddField(
            model_name='historicalinvoice',
            name='currency',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='customers.Currency'),
        ),
        migrations.AddField(
            model_name='historicalinvoice',
            name='tasa',
            field=models.DecimalField(blank=True, decimal_places=5, max_digits=20, null=True, verbose_name='tasa'),
        ),
        migrations.AddField(
            model_name='historicalpayment',
            name='currency',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='customers.Currency'),
        ),
        migrations.AddField(
            model_name='historicalpayment',
            name='number_document',
            field=models.BigIntegerField(blank=True, null=True),
        ),
        migrations.AddField(
            model_name='historicalpayment',
            name='tasa',
            field=models.DecimalField(blank=True, decimal_places=5, max_digits=20, null=True, verbose_name='tasa'),
        ),
        migrations.AddField(
            model_name='historicalprovider',
            name='currency',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='customers.Currency'),
        ),
        migrations.AddField(
            model_name='invoice',
            name='currency',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='invoice_provider_currency', to='customers.Currency'),
        ),
        migrations.AddField(
            model_name='invoice',
            name='tasa',
            field=models.DecimalField(blank=True, decimal_places=5, max_digits=20, null=True, verbose_name='tasa'),
        ),
        migrations.AddField(
            model_name='payment',
            name='currency',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='customers.Currency'),
        ),
        migrations.AddField(
            model_name='payment',
            name='number_document',
            field=models.BigIntegerField(blank=True, null=True),
        ),
        migrations.AddField(
            model_name='payment',
            name='tasa',
            field=models.DecimalField(blank=True, decimal_places=5, max_digits=20, null=True, verbose_name='tasa'),
        ),
        migrations.AddField(
            model_name='provider',
            name='currency',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='customers.Currency'),
        ),
        migrations.AlterField(
            model_name='historicalinvoice',
            name='exento',
            field=models.DecimalField(decimal_places=2, default=0, max_digits=12, verbose_name='exento'),
        ),
        migrations.AlterField(
            model_name='historicalinvoice',
            name='iva',
            field=models.DecimalField(decimal_places=2, default=0, max_digits=12, verbose_name='iva'),
        ),
        migrations.AlterField(
            model_name='historicalinvoice',
            name='neto',
            field=models.DecimalField(decimal_places=2, default=0, max_digits=12, verbose_name='neto'),
        ),
        migrations.AlterField(
            model_name='historicalinvoice',
            name='tax',
            field=models.DecimalField(decimal_places=2, default=0, max_digits=12, verbose_name='impuesto adicional'),
        ),
        migrations.AlterField(
            model_name='historicalinvoice',
            name='total',
            field=models.DecimalField(decimal_places=2, default=0, max_digits=12, verbose_name='Total'),
        ),
        migrations.AlterField(
            model_name='historicalpayment',
            name='amount',
            field=models.DecimalField(decimal_places=2, default=0, max_digits=12, verbose_name='payment amount'),
        ),
        migrations.AlterField(
            model_name='invoice',
            name='exento',
            field=models.DecimalField(decimal_places=2, default=0, max_digits=12, verbose_name='exento'),
        ),
        migrations.AlterField(
            model_name='invoice',
            name='iva',
            field=models.DecimalField(decimal_places=2, default=0, max_digits=12, verbose_name='iva'),
        ),
        migrations.AlterField(
            model_name='invoice',
            name='neto',
            field=models.DecimalField(decimal_places=2, default=0, max_digits=12, verbose_name='neto'),
        ),
        migrations.AlterField(
            model_name='invoice',
            name='tax',
            field=models.DecimalField(decimal_places=2, default=0, max_digits=12, verbose_name='impuesto adicional'),
        ),
        migrations.AlterField(
            model_name='invoice',
            name='total',
            field=models.DecimalField(decimal_places=2, default=0, max_digits=12, verbose_name='Total'),
        ),
        migrations.AlterField(
            model_name='payment',
            name='amount',
            field=models.DecimalField(decimal_places=2, default=0, max_digits=12, verbose_name='payment amount'),
        ),
        migrations.RunSQL(sql),
        migrations.RunSQL(balance_sql)
    ]
